← All problems

99. Recover Binary Search Tree

MediumOpen on LeetCodeProblem statement

Problem Statement

99. Recover Binary Search Tree

Medium


You are given the root of a binary search tree (BST), where the values of exactly two nodes of the tree were swapped by mistake. Recover the tree without changing its structure.

 

Example 1:

Input: root = [1,3,null,null,2]
Output: [3,1,null,null,2]
Explanation: 3 cannot be a left child of 1 because 3 > 1. Swapping 1 and 3 makes the BST valid.

Example 2:

Input: root = [3,1,4,null,null,2]
Output: [2,1,4,null,null,3]
Explanation: 2 cannot be in the right subtree of 3 because 2 < 3. Swapping 2 and 3 makes the BST valid.

 

Constraints:

 

Follow up: A solution using O(n) space is pretty straight-forward. Could you devise a constant O(1) space solution?

C++

Source file
/**
 * Definition for a binary tree node.
 * struct TreeNode {
 *     int val;
 *     TreeNode *left;
 *     TreeNode *right;
 *     TreeNode() : val(0), left(nullptr), right(nullptr) {}
 *     TreeNode(int x) : val(x), left(nullptr), right(nullptr) {}
 *     TreeNode(int x, TreeNode *left, TreeNode *right) : val(x), left(left), right(right) {}
 * };
 */
class Solution {
public:
	TreeNode* firstMistake, *secondMistake, *prev;
	void recoverTree(TreeNode* root) {
		prev = new TreeNode(INT_MIN);
		inorder(root);
		swap(firstMistake->val, secondMistake->val);
	}

	void inorder(TreeNode* root) {
        // null ptr check
		if(root == nullptr) 
			return;

		inorder(root->left);
        
		if(firstMistake == nullptr && root->val < prev->val)    // if 1st mistake is not yet marked
			firstMistake = prev;
		if(firstMistake != nullptr && root->val < prev->val)    // if 1st mistake isSet already
			secondMistake = root;
		prev = root;

		inorder(root->right);
	}
};